<?php 



class ActesEnvelopeSerialSQL {

	private $db;
	private $errorMsg;
	
	public function __construct(Database $db){
		$this->db = $db;
	}
	
	public function getLastError(){
		return $this->errorMsg;
	}
	
	public function getNext($authority_id) {
		if (! $this->db->begin()) {
			$this->errorMsg = "Erreur lors de l'initialisation de la transaction.";
			return false;
		}

	  	// On vrifie si le numro doit tre remis  zro ou pas
	  	$sql = "SELECT reset_date, serial " .
	  			" FROM actes_envelope_serials " .
	  			" WHERE authority_id=$authority_id FOR UPDATE";
		$result = $this->db->select($sql);

		if ($result->isError()) {
			$this->errorMsg = "Erreur d'accs base de donnes.";
			return false;
		}
		
		if ($result->num_row() <= 0) {
		  // Pas encore d'entre pour cette collectivit
		  $date = date('Y-m-d');
		  $sql = "INSERT INTO actes_envelope_serials (authority_id, reset_date, serial) VALUES($authority_id, '$date', 2)";

		  if (! $this->db->exec($sql)) {
			$this->errorMsg = "Erreur d'accs base de donnes.";
			$this->db->rollback();
			return false;
		  } else {
			$this->db->commit();
			return 1;
		  }
		} else {
		  $row = $result->get_next_row();
		  $date = substr($row["reset_date"], 0, 10);
		  $today = date('Y-m-d');

		  if (strcmp($today, $date) != 0) {
			// La dernire remise  zro n'est pas d'aujourd'hui => on remet  zro le compteur
			$sql = "UPDATE actes_envelope_serials SET reset_date='" . pg_escape_string($today) . "', serial=2 WHERE authority_id=$authority_id" ;

			if (! $this->db->exec($sql)) {
			  $this->errorMsg = "Erreur d'accs base de donnes.";
			  $this->db->rollback();
			  return false;
			} else {
			  $this->db->commit();
			  return 1;
			}
		  } else {
			// Mise  jour aujourd'hui => on incrmente le numro de srie
			
		  // pour le bug 240, modifi par HTan, 15-12-2008
			if ($row['serial']>=10000 || $row['serial']<=0)
			{
				$this->errorMsg = "Serial number: dborder 10000. Vrifier serial est modifi par quelqu'un ou on a commit plus que 9999 tranactions par jour.";
				return false;
			}
			//-----
			
			$sql = "UPDATE actes_envelope_serials SET serial=serial+1 WHERE authority_id=$authority_id";

			if (! $this->db->exec($sql)) {
			  $this->errorMsg = "Erreur d'accs base de donnes.";
			  $this->db->rollback();
			  return false;
			} else {
			  $this->db->commit();
			  return $row["serial"];
			}
		  }
		}
	 
  }
	
}